
package net.mcreator.vibraniumandneutronium.client.gui;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.TextComponent;
import net.minecraft.network.chat.Component;
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import net.minecraft.client.gui.components.Button;
import net.minecraft.client.Minecraft;

import net.mcreator.vibraniumandneutronium.world.inventory.TrrrrrMenu;
import net.mcreator.vibraniumandneutronium.network.TrrrrrButtonMessage;
import net.mcreator.vibraniumandneutronium.VibraniumAndNeutroniumMod;

import com.mojang.blaze3d.vertex.PoseStack;
import com.mojang.blaze3d.systems.RenderSystem;

public class TrrrrrScreen extends AbstractContainerScreen<TrrrrrMenu> {
	private final Level world;
	private final int x, y, z;
	private final Player entity;

	public TrrrrrScreen(TrrrrrMenu container, Inventory inventory, Component text) {
		super(container, inventory, text);
		this.world = container.world;
		this.x = container.x;
		this.y = container.y;
		this.z = container.z;
		this.entity = container.entity;
		this.imageWidth = 176;
		this.imageHeight = 179;
	}

	private static final ResourceLocation texture = new ResourceLocation("vibranium_and_neutronium:textures/trrrrr.png");

	@Override
	public void render(PoseStack ms, int mouseX, int mouseY, float partialTicks) {
		this.renderBackground(ms);
		super.render(ms, mouseX, mouseY, partialTicks);
		this.renderTooltip(ms, mouseX, mouseY);
	}

	@Override
	protected void renderBg(PoseStack ms, float partialTicks, int gx, int gy) {
		RenderSystem.setShaderColor(1, 1, 1, 1);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();
		RenderSystem.setShaderTexture(0, texture);
		this.blit(ms, this.leftPos, this.topPos, 0, 0, this.imageWidth, this.imageHeight, this.imageWidth, this.imageHeight);
		RenderSystem.disableBlend();
	}

	@Override
	public boolean keyPressed(int key, int b, int c) {
		if (key == 256) {
			this.minecraft.player.closeContainer();
			return true;
		}
		return super.keyPressed(key, b, c);
	}

	@Override
	public void containerTick() {
		super.containerTick();
	}

	@Override
	protected void renderLabels(PoseStack poseStack, int mouseX, int mouseY) {
		this.font.draw(poseStack, "X", 16, 19, -12829636);
		this.font.draw(poseStack, "-X", 43, 19, -12829636);
		this.font.draw(poseStack, "Z", 97, 19, -12829636);
		this.font.draw(poseStack, "-Z", 70, 19, -12829636);
		this.font.draw(poseStack, "250", 142, 19, -12829636);
		this.font.draw(poseStack, "500", 142, 37, -12829636);
		this.font.draw(poseStack, "1000", 142, 55, -12829636);
		this.font.draw(poseStack, "1500", 142, 73, -12829636);
		this.font.draw(poseStack, "+ 100 Y", 43, 64, -12829636);
		this.font.draw(poseStack, "u need to put fuel in 250 ", 16, 1, -12829636);
		this.font.draw(poseStack, "in order to put it in 500", 16, 10, -12829636);
	}

	@Override
	public void onClose() {
		super.onClose();
		Minecraft.getInstance().keyboardHandler.setSendRepeatsToGui(false);
	}

	@Override
	public void init() {
		super.init();
		this.minecraft.keyboardHandler.setSendRepeatsToGui(true);
		this.addRenderableWidget(new Button(this.leftPos + 25, this.topPos + 73, 72, 20, new TextComponent("TRANSPORT"), e -> {
			if (true) {
				VibraniumAndNeutroniumMod.PACKET_HANDLER.sendToServer(new TrrrrrButtonMessage(0, x, y, z));
				TrrrrrButtonMessage.handleButtonAction(entity, 0, x, y, z);
			}
		}));
	}
}
