
package net.mcreator.vibraniumandneutronium.item;

import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.item.Tier;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.CreativeModeTab;
import net.minecraft.world.item.AxeItem;

import net.mcreator.vibraniumandneutronium.init.VibraniumAndNeutroniumModItems;

public class OhItem extends AxeItem {
	public OhItem() {
		super(new Tier() {
			public int getUses() {
				return 8100;
			}

			public float getSpeed() {
				return 10f;
			}

			public float getAttackDamageBonus() {
				return 8f;
			}

			public int getLevel() {
				return 5;
			}

			public int getEnchantmentValue() {
				return 20;
			}

			public Ingredient getRepairIngredient() {
				return Ingredient.of(new ItemStack(VibraniumAndNeutroniumModItems.VIBRANIUMSTAR));
			}
		}, 1, -2.9f, new Item.Properties().tab(CreativeModeTab.TAB_TOOLS).fireResistant());
		setRegistryName("oh");
	}
}
